/**
 * Created by zhanghuihua on 2016/12/15.
 */
var dwzMap = {

    config: {
        addMarker:{
            map:null,
            point:null,
            iconUrl:'./images/markers.png',
            iconWidth:25,
            iconHeight:40,
            imageOffsetLeft: 0,
            imageOffsetTop: 0
        }
    },

    /**
     * 创建图标对象
     * @param options
     */
    addMarker: function(options, callback) {
        var op = $.extend({}, dwzMap.config.addMarker, options);

        var myIcon = new BMap.Icon(op.iconUrl, new BMap.Size(op.iconWidth, op.iconHeight), {
            imageSize: false,
            // 指定定位位置。图标中央下端的尖角位置。
            anchor: new BMap.Size(op.iconWidth/2, op.iconHeight),
            // 设置图片偏移。当您需要从一幅较大的图片中截取某部分作为标注图标时，您需要指定大图的偏移位置，此做法与css sprites技术类似。
            imageOffset: new BMap.Size(op.imageOffsetLeft, op.imageOffsetTop)
        });
        // 创建标注对象并添加到地图
        var marker = new BMap.Marker(op.point, {icon: myIcon});
        op.map.addOverlay(marker);

        if (callback) {callback(marker);}

        return marker;
    },

    apInfoWindow:function(marker, item, options){
        var op = $.extend({
            frag:'<div class="InfoWindow">'
            + '<p>#address#</p>'
            + '<p>经度：#lng# &nbsp;&nbsp; 纬度：#lat#</p>'
            + '</div>',
            showStatus: true,
            showCount:true,
            showTime : false
        }, options);

        var content = op.frag.replaceAll('#address#', item.address ? '地址：'+item.address: '')
            .replaceAll('#lng#', item.lng).replaceAll('#lat#', item.lat);

        var infoOpt = { title: '<h2 class="InfoWindowTitle">名称：'+item.name+'</h2>'};
        var infoWindow = new BMap.InfoWindow("<div class='InfoWindow'>" + content + "</div>", infoOpt);
        marker.addEventListener("click", function() {
            this.openInfoWindow(infoWindow);
        });
    }
};

/*
dwz.regPlugins.push(function($p){

    $('div.dwz-bmap', $p).each(function(){
        var $box = $(this);

        if ($box.hasClass('dwz-fullscreen')){
            $box.css({'height': document.documentElement.clientHeight + 'px'});
        }

        var map = new BMap.Map($box.attr('id'));
        var centerPoint = {lng:116.403963, lat:39.915119};

        var point = new BMap.Point(centerPoint.lng, centerPoint.lat);
        map.centerAndZoom(point, 15);
        // map.addControl(new BMap.NavigationControl({anchor:BMAP_ANCHOR_TOP_RIGHT}));
        map.enableScrollWheelZoom();

        dwzMap.addMarker({map:map, point:point, iconWidth:23, iconHeight:25, imageOffsetLeft: 0, imageOffsetTop: -275}, function(marker){
            var content = '<div class="InfoWindow">'
                + '<p>地址：xxx</p>'
                + '<p>经度：xx &nbsp;&nbsp; 纬度：xx</p>'
                + '</div>';

            var infoOpt = { title: '<h2 class="InfoWindowTitle">名称：xxx</h2>'};
            var infoWindow = new BMap.InfoWindow("<div class='InfoWindow'>" + content + "</div>", infoOpt);
            marker.addEventListener("click", function () {
                this.openInfoWindow(infoWindow);
            });
        });
    });
});
*/