/**
 * DWZ Mobile Framework: ajax history plugins
 * @author z@j-ui.com
 */
(function($){

	$.extend({
		
		history: {
			_hash: new Array(),
			_currentHash: "",
			_isPop: false,
			_isHis:true,
			init: function(callback, hash){
				var current_hash = (hash || location.hash);

				if (current_hash) {
					$.history._currentHash = current_hash.skipChar("#").replace('?','|');

					if ($.isFunction(callback)) {
						setTimeout(function () {
							callback(current_hash.skipChar("#").replace('|', '?'));
						}, 200);
					}
				}

				window.onhashchange = $.history._check;
			},
			_check: function(){
				var current_hash = location.hash.skipChar('#').replace('?','|');
				if (!current_hash) $(window).trigger('hash.empty');

				if (!$.history._isHis && $.history._isPop)  {
					$.history._isHis = true;
					return;
				}

				if (current_hash && current_hash != $.history._currentHash) {
					$.history._currentHash = current_hash;
					$.history.load(current_hash);
				}
				$.history._isHis = true;
			},
			add: function(hash, fun, args){
				hash = hash.replace('?','|').replace(/\?.*$/, '');

				$.history._isPop = false;
				$.history._currentHash = hash;
				$.history._hash.push([hash, fun, args]);

				location.hash = hash;
			},
			pop: function(local) {
				if(local) {
					$.history._isPop = true;
					$.history._isHis = false;
				} else {
					$.history._isPop = false;
					$.history._isHis = true;
				}
				if ($.history._hash.length > 0) {
					$.history._hash.pop();
					// location.hash = $.history._hash[$.history._hash.length -1][0];

					if(local) {
						history.back(); // 处理点击页面返回按钮，再点击android返回按键问题
					}
				} else {
					$(window).trigger('hash.empty');
				}
			},
			load: function(hash){

				for (var i = 0; i < $.history._hash.length; i += 1) {
					var fun = $.history._hash[i][1];
					if ($.history._hash[i][0] == hash && fun) {
						fun($.history._hash[i][2]);
						return;
					}
				}
			}
		}
	});
})(dwz);
